
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_ADXL345_U.h>
#include <ModbusRtu.h>
#include "EmonLib.h"
// Include Emon Library

// assign the Arduino pin that must be connected to RE-DE RS485 transceiver
#define TXEN  8 
int analogPin = 0;
// data array for modbus network sharing
uint16_t au16data[4] = {
  0, 0, 0, 0};
EnergyMonitor emon1;
Adafruit_ADXL345_Unified accel = Adafruit_ADXL345_Unified();

/**
 *  Modbus object declaration
 *  u8id : node id = 0 for master, = 1..247 for slave
 *  port : serial port
 *  u8txenpin : 0 for RS-232 and USB-FTDI 
 *               or any pin number > 1 for RS-485
 */
Modbus slave(11,Serial,TXEN); // this is slave @1 and RS-485


void setup() {
  Serial.begin(19200); // baud-rate at 19200
  slave.start();
  emon1.current(0, 60);   
  if(!accel.begin())
     {
        Serial.println("No ADXL345 sensor detected.");
        while(1);
     }
}

void loop() {
  sensors_event_t event; 
  accel.getEvent(&event);
  
  //Serial.print("X: "); Serial.print(event.acceleration.x); Serial.print("  ");
  //Serial.print("Y: "); Serial.print(event.acceleration.y); Serial.print("  ");
  //Serial.print("Z: "); Serial.print(event.acceleration.z); Serial.print("  ");
  //Serial.println("m/s^2 ");
  float cur = analogRead(analogPin);
  float currt = cur  * (1/1024) * 1000;
  double Irms = emon1.calcIrms(200);  // Calculate Irms only
  //Serial.println(au16data[1]);
  //float data = au16data[1]/1000;
  //Serial.println(Irms);
  au16data[0]=Irms*100;
  au16data[1]=((event.acceleration.x+20)*10000);
  au16data[2]=((event.acceleration.y+20)*10000);
  au16data[3]=((event.acceleration.z+20)*10000);
  slave.poll( au16data, 16 );
  Serial.println(au16data[1]);
  

}
